//
// To compile:
// g++ -o rat -w all Rational.cpp main.cpp
//

#include "Rational.h"
#include "Tester.h"
#include <iostream>

main(int argc, char * argv[] ) {

	using namespace std;

	Rational a(3), b(2,3), c, d;
	c = a + b;
	// should print 3/1 + 2/3 = 11/3 
	cout << a << " + " << b << " = " << c << endl; 
	d = c -  b;

	// should print 11/3 - 2/3 = 9/3
	cout << c << " - " << b << " = " << d << endl; 

	a = Rational(1,7); b = Rational(1,9);
	cout << (a + b) << endl; // should print 16/63
	if (a == b) cout << "a is equal to b" << endl;
	if (a < b) cout << "a is less than b" << endl;
	if (a > b) cout << "a is greater than b" << endl;

	cout << "b as a double = " << b.asDouble() << endl;
	b.print(cout);
	cout << endl;
	
	// test reduce method
	Rational r(3,12);
	cout << "Rational r(3/12) = " << r << endl; // prints 1/4
	r.set(84204, 357867);
	cout << "Rational r(84204/357867) = " << r << endl; // prints 4/17
	cout << r << " * " << c << " = " << r * c << endl;
	cout << "Beginning test..." << endl;
	Tester myTest;
	myTest.test();
	cout << "End of test..." << endl;
}

